DEFine PROCedure setup_ledmeter(xs%,ys%,xo%,yo%,lmeter)
REMark this sets up the window containing the ledmeter, with the right size
LOCal sz%(3)
  IF ys%=-1:ys%=14
  IF xs%=-1
    xs%=lmeter(1)*6+4
  END IF
  IF xo%=-1 AND yo%=-1
    WSIZE#lmeter(0),sz%
    xs%=sz%(0):ys%=sz%(1)
    xo%=sz%(2):yo%=sz%(3)
  ELSE
    WINDOW#lmeter(0),xs%,ys%,xo%,yo%
  END IF
  PAPER#lmeter(0),0
  CLS#lmeter(0) 			: REMark clear this channel
  lmeter(3)=(xs%-4 -lmeter(1)) DIV lmeter(1)
  lmeter(5)=(xs%-lmeter(1)*(lmeter(3)+1))DIV 2
  lmeter(6)=3:lmeter(4)=ys%-6
  lmeter(11)=lmeter(1)			: REMark pretend all leds were on
  empty_ledmeter lmeter,0		: REMark so now switch them off
  lmeter(11)=1
END DEFine setup_ledmeter
:
DEFine PROCedure empty_ledmeter (lmeter,nbr2%)
REMark "empty" all leds above the number nbr% (starting at 1= first led)!
REMark i.e. empty... 1 ->led 1 stays lit. Use empty... 0 to empty all
REMark this also uses the previous state of the ledmeter (i.e. lmeter(11)) to check
REMark where it has to stop
LOCal lp%,redstart%,nbr%
  nbr%=nbr2%
  IF nbr%>=lmeter(11):RETurn		: REMark no need to empty if first led to empty is in empty fields
  redstart%=lmeter(1)-lmeter(2)-1	 : REMark start of red leds
  l_yo%=lmeter(6)
  l_xs%=lmeter(3)
  l_ys%=lmeter(4)
  l_c%=lmeter(0)
  l_xo%=lmeter(3)+1
  IF nbr%<1:nbr%=1
  FOR lp%=nbr%-1 TO lmeter(11)-1
    IF lp%>redstart%
      BLOCK#l_c%,l_xs%,l_ys%,lp%*l_xo%+lmeter(5),l_yo%,lmeter(9)
    ELSE
      BLOCK#l_c%,l_xs%,l_ys%,lp%*l_xo%+lmeter(5),l_yo%,lmeter(7)
    END IF
  END FOR lp%
END DEFine empty_ledmeter
:
DEFine PROCedure show_ledmeter (lmeter,nbr2%)
REMark Show number nbr2% in the ledmeter
LOCal lp%,nbr%,redstart%
  nbr%=nbr2%
  IF nbr%>lmeter(1):nbr%=lmeter(1)	: REMark don'texceed max value of ledmeter
  IF nbr%=lmeter(11):RETurn		: REMark the same value as earlier one - don't do anything
  empty_ledmeter lmeter,nbr%		: REMark empty everything above this number
  REMark IF NOT nbr%:RETurn
  IF nbr%<lmeter(11)
    lmeter(11)=nbr%			: REMark we only needed to empty some leds
    RETurn
  END IF
  redstart%=lmeter(1)-lmeter(2)-1	: REMark start of red leds
  l_yo%=lmeter(6)
  l_xs%=lmeter(3)
  l_ys%=lmeter(4)
  l_c%=lmeter(0)
  l_xo%=lmeter(3)+1
  FOR lp%=lmeter(11)-1 TO nbr%-1
      IF lp%>redstart%
	BLOCK#l_c%,l_xs%,l_ys%,lp%*l_xo%+lmeter(5),l_yo%,lmeter(10)
      ELSE
	BLOCK#l_c%,l_xs%,l_ys%,lp%*l_xo%+lmeter(5),l_yo%,lmeter(8)
      END IF
  END FOR lp%
  lmeter(11)=nbr%
END DEFine show_ledmeter
:
DEFine PROCedure init_ledmeters
  REMark ledmeter(0)=channel_nbr
  REMark ledmeter(1)=max nbr of elements
  REMark ledmeter(2)=nbr of "red" elements
  REMark ledmeter(3)=xsize of each element
  REMark ledmeter(4)=ysize of each element
  REMark ledmeter(5)=xoff
  REMark ledmeter(6)=yoff
  REMark ledmeter(7)=normal background, off
  REMark ledmeter(8)=normal background, on
  REMark ledmeter(9)=warn background, off
  REMark ledmeter(10)=warn background, on
  REMark ledmeter(11)=old value displayed
  DIM ledmeterleft(11)
  ledmeterleft(0)=FOPEN('con')
  dr_iwdf#ledmeterleft(0),main_defn,3
  ledmeterleft(1)=26
  ledmeterleft(2)=3
  ledmeterleft(7)=HEX('7F7F00'):ledmeterleft(8)=HEX('FFFF00')
  ledmeterleft(9)=HEX('7F0000'):ledmeterleft(10)=HEX('FF0000')
  setup_ledmeter 180,10,-1,-1,ledmeterleft
  DIM ledmeterright(11)
  ledmeterright(0)=FOPEN('con')
  dr_iwdf#ledmeterright(0),main_defn,4
  ledmeterright(1)=26
  ledmeterright(2)=3
  ledmeterright(7)=HEX('7F7F00'):ledmeterright(8)=HEX('FFFF00')
  ledmeterright(9)=HEX('7F0000'):ledmeterright(10)=HEX('FF0000')
  setup_ledmeter 180,10,-1,-1,ledmeterright
END DEFine init_ledmeters
:
DEFine PROCedure sample
  SOUNDSAMPLE2 10,30,l%,r%
  show_ledmeter ledmeterleft,l%
  show_ledmeter ledmeterright,r%
END DEFine sample
:
