*****************************************************
*
* SOUNDSAMPLE3 div%,end%,TRUBO_V(channel1%),TURBO_V(channel2%)
* gets a soundsample, returns it in channel1%,channel2%
* div% is a calling parameter, divisor, values will be DIVed by that
* end% is a param that wil be used if no sound is being sent
* (use 1, not 0, if no divisor needed
* v  1.01 2004 Dec 09 19:46:00 -  by Rich Mellor for Turbo
*(c) Rich Mellor 2004
*****************************************************
   

	section sound
	xdef	soundsample3
	xref	soundcom
	xref	sf_nosss
	xref	bp_err

	include dev8_keys_qdos_io
	include dev8_keys_qdos_ioa
	include dev8_smsq_q40_hdop_data
	include dev8_keys_68000
	include dev8_keys_err
	include dev8_keys_sss
	include dev8_keys_sbasic
	include dev8_keys_qdos_sms
	include dev8_keys_qlv


ssss_qin	equ $14
ssss_qout	equ $18

    
* Check for Turbo
* Sets CC Z if compiled by Turbo
* Uses no registers
turbot
	movem.l a0-a1/d0-d2,-(a7)
	moveq	#-1,d1
	moveq	#0,d2
	moveq	#02,d0			; Get current job information
	trap	#1
	cmpi.l	#'Turb',34(a0)		; This is always set in a Turbo compiled job
	movem.l (a7)+,a0-a1/d0-d2
	rts

soundsample3
	bsr.s	turbot			; Are we in a turbo program?
	bne	soundcom		; no, call soundsample2

	move.l	a3,d0
	add.l	#32,d0			; 3 params only?
	cmp.l	d0,a5
	bne	bp_err			; no!
	lea	16(a3),a5
	move.w	$112,a2
	jsr	(a2)			; get divisor
	move.l	(a6,a1.l),d6		; div | end
	addq.l	#4,$58(a6)

	move.l	a5,a3
	lea	16(a3),a5
	move.w	$118,a2
	jsr	(a2)			; Get the two channel pointers
	move.l	(a1,a6.l),a0		; Pointer to channel 0
	move.l	(a0),a0
	move.l	4(a1,a6.l),a1		; Pointer to channel 1
	move.l	(a1),a1
	addq.l	#8,$58(a6)

	move.w	d6,d7
	move.w	d6,d0			; preset no sound !
	move.l	a3,a4
	move.l	exv_i4,a3		; point to Interrupt level 4
	move.l	-(a3),a2		; this could be SSSS vector
	cmp.l	#sss.flag,-(a3) 	; is it really?
	bne	sf_nosss		; no!
	move.l	ssss_qout(a3),a2	; next out
	cmp.l	ssss_qin(a3),a2 	; any sound?
	beq.s	nosnd2			; no
	move.b	(a2),d0
	move.b	1(a2),d7
	swap	d6
	divu.w	d6,d0
	divu.w	d6,d7
nosnd2
	move.w	d7,(a0) 		; Set the current channel 2 pointer
	move.w	d0,(a1) 		; Set the current channel 1 pointer
	moveq	#0,d0
	rts
	
	end
